local AceGUI = LibStub("AceGUI-3.0")

local maxWidth;

function MorthalinRaidTools:ConstructIconTable(object, data)
	if(self.ui.iconTable ~= nil) then
		self.ui.iconTable:Hide();
	end
	self.ui.iconTable = nil;
	if(self.ui.iconTable == nil) then
		local FrameBackdrop = {
			bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			tile = true, tileSize = 32, edgeSize = 16,
			insets = { left = 5, right = 5, top = 5, bottom = 5 }
		}
		
		self.ui.iconTable = CreateFrame("Frame",nil,object);
		self.ui.iconTable:SetFrameStrata("TOOLTIP");
		self.ui.iconTable:SetWidth(107);
		self.ui.iconTable:SetHeight(100);
		maxWidth = 107;

		self.ui.iconTable:EnableMouse(true);
		self.ui.iconTable:SetMovable(false);
		self.ui.iconTable:SetResizable(false);
		self.ui.iconTable:SetBackdrop(FrameBackdrop);
		self.ui.iconTable:SetBackdropColor(0, 0, 0, 1);
		self.ui.iconTable:SetToplevel(true);
		
	end
	self:SetIconTableRows(data);
	self.ui.iconTable:SetPoint("TOPLEFT", (self.ui.iconTable:GetWidth() * (-1)), 0);
end

function MorthalinRaidTools:SetIconTableIcons(icons, top)
	local index = 1;
	local left = 112;
	if(icons ~= nil) then
		for name, icon in pairs(icons) do
			local iconGUI = CreateFrame("BUTTON", nil, self.ui.iconTable, "SecureHandlerClickTemplate");
			iconGUI:SetSize(16, 16);
			iconGUI:SetPoint("TOPLEFT", left, top * (-1));
			
			local image = iconGUI:CreateTexture(nil,"BACKGROUND",nil,-6);
			image:SetTexture(icon);
			image:SetTexCoord(0, 1, 0, 1);
			image:SetAllPoints(iconGUI);
			iconGUI.name = name;
			iconGUI:SetScript("OnEnter", function()
				GameTooltip:SetOwner(iconGUI,"ANCHOR_LEFT");
				GameTooltip:AddLine(name);
				GameTooltip:Show();
			end);
			iconGUI:SetScript("OnLeave", function() GameTooltip:Hide(); end);
			left = left + 17;
		end
	end
	if(maxWidth < left) then
		maxWidth = left;
		self.ui.iconTable:SetWidth(left + 4);
	end
end

function MorthalinRaidTools:SetIconTableRows(data)
	local top = 7;
	local index = 1;
	for i = 1, #data do
		local row = CreateFrame("Frame", nil, self.ui.iconTable);
		row:SetWidth(100);
		row:SetHeight(10);
		row:SetPoint("TOPLEFT", 7, top * (-1));
		row.text = row:CreateFontString(nil, "ARTWORK");
		row.text:SetFont(GameFontNormal:GetFont());
		row.text:SetJustifyH("LEFT");
		row.text:SetJustifyV("TOP");
		row.text:SetText("|cff" .. data[i].color .. data[i].name);
		row.text:SetAllPoints(row);
		MorthalinRaidTools:SetIconTableIcons(data[i].buffs, top);
		top = top + 17;
		index = index + 1;
	end
	self.ui.iconTable:SetHeight(top + 4);
end
